from asdl import pybase

option_t = int  # type alias for integer

class option_i(object):
  errexit = 1
  nounset = 2
  hashall = 3
  pipefail = 4
  noexec = 5
  xtrace = 6
  verbose = 7
  noglob = 8
  noclobber = 9
  posix = 10
  vi = 11
  emacs = 12
  interactive = 13
  failglob = 14
  extglob = 15
  eval_unsafe_arith = 16
  parse_dynamic_arith = 17
  compat_array = 18
  verbose_errexit = 19
  allow_command_sub = 20
  nullglob = 21
  inherit_errexit = 22
  strict_argv = 23
  strict_arith = 24
  strict_array = 25
  strict_control_flow = 26
  strict_echo = 27
  strict_errexit = 28
  strict_eval_builtin = 29
  strict_nameref = 30
  strict_word_eval = 31
  strict_tilde = 32
  strict_glob = 33
  strict_backslash = 34
  strict_backticks = 35
  strict_dollar = 36
  simple_word_eval = 37
  dashglob = 38
  command_sub_errexit = 39
  process_sub_fail = 40
  simple_test_builtin = 41
  parse_at = 42
  parse_brace = 43
  parse_index_expr = 44
  parse_paren = 45
  parse_rawc = 46
  parse_ignored = 47
  parse_set = 48
  parse_equals = 49
  parse_at_all = 50
  parse_tea = 51
  expand_aliases = 52
  lastpipe = 53
  progcomp = 54
  histappend = 55
  hostcomplete = 56
  cmdhist = 57
  assoc_expand_once = 58
  autocd = 59
  cdable_vars = 60
  cdspell = 61
  checkhash = 62
  checkjobs = 63
  checkwinsize = 64
  complete_fullquote = 65
  direxpand = 66
  dirspell = 67
  dotglob = 68
  execfail = 69
  extdebug = 70
  extquote = 71
  force_fignore = 72
  globasciiranges = 73
  globstar = 74
  gnu_errfmt = 75
  histreedit = 76
  histverify = 77
  huponexit = 78
  interactive_comments = 79
  lithist = 80
  localvar_inherit = 81
  localvar_unset = 82
  login_shell = 83
  mailwarn = 84
  no_empty_cmd_completion = 85
  nocaseglob = 86
  nocasematch = 87
  progcomp_alias = 88
  promptvars = 89
  restricted_shell = 90
  shift_verbose = 91
  sourcepath = 92
  xpg_echo = 93
  ARRAY_SIZE = 94

_option_str = {
  1: 'option.errexit',
  2: 'option.nounset',
  3: 'option.hashall',
  4: 'option.pipefail',
  5: 'option.noexec',
  6: 'option.xtrace',
  7: 'option.verbose',
  8: 'option.noglob',
  9: 'option.noclobber',
  10: 'option.posix',
  11: 'option.vi',
  12: 'option.emacs',
  13: 'option.interactive',
  14: 'option.failglob',
  15: 'option.extglob',
  16: 'option.eval_unsafe_arith',
  17: 'option.parse_dynamic_arith',
  18: 'option.compat_array',
  19: 'option.verbose_errexit',
  20: 'option.allow_command_sub',
  21: 'option.nullglob',
  22: 'option.inherit_errexit',
  23: 'option.strict_argv',
  24: 'option.strict_arith',
  25: 'option.strict_array',
  26: 'option.strict_control_flow',
  27: 'option.strict_echo',
  28: 'option.strict_errexit',
  29: 'option.strict_eval_builtin',
  30: 'option.strict_nameref',
  31: 'option.strict_word_eval',
  32: 'option.strict_tilde',
  33: 'option.strict_glob',
  34: 'option.strict_backslash',
  35: 'option.strict_backticks',
  36: 'option.strict_dollar',
  37: 'option.simple_word_eval',
  38: 'option.dashglob',
  39: 'option.command_sub_errexit',
  40: 'option.process_sub_fail',
  41: 'option.simple_test_builtin',
  42: 'option.parse_at',
  43: 'option.parse_brace',
  44: 'option.parse_index_expr',
  45: 'option.parse_paren',
  46: 'option.parse_rawc',
  47: 'option.parse_ignored',
  48: 'option.parse_set',
  49: 'option.parse_equals',
  50: 'option.parse_at_all',
  51: 'option.parse_tea',
  52: 'option.expand_aliases',
  53: 'option.lastpipe',
  54: 'option.progcomp',
  55: 'option.histappend',
  56: 'option.hostcomplete',
  57: 'option.cmdhist',
  58: 'option.assoc_expand_once',
  59: 'option.autocd',
  60: 'option.cdable_vars',
  61: 'option.cdspell',
  62: 'option.checkhash',
  63: 'option.checkjobs',
  64: 'option.checkwinsize',
  65: 'option.complete_fullquote',
  66: 'option.direxpand',
  67: 'option.dirspell',
  68: 'option.dotglob',
  69: 'option.execfail',
  70: 'option.extdebug',
  71: 'option.extquote',
  72: 'option.force_fignore',
  73: 'option.globasciiranges',
  74: 'option.globstar',
  75: 'option.gnu_errfmt',
  76: 'option.histreedit',
  77: 'option.histverify',
  78: 'option.huponexit',
  79: 'option.interactive_comments',
  80: 'option.lithist',
  81: 'option.localvar_inherit',
  82: 'option.localvar_unset',
  83: 'option.login_shell',
  84: 'option.mailwarn',
  85: 'option.no_empty_cmd_completion',
  86: 'option.nocaseglob',
  87: 'option.nocasematch',
  88: 'option.progcomp_alias',
  89: 'option.promptvars',
  90: 'option.restricted_shell',
  91: 'option.shift_verbose',
  92: 'option.sourcepath',
  93: 'option.xpg_echo',
}

def option_str(val):
  # type: (option_t) -> str
  return _option_str[val]

builtin_t = int  # type alias for integer

class builtin_i(object):
  colon = 1
  dot = 2
  exec_ = 3
  eval = 4
  set = 5
  shift = 6
  times = 7
  trap = 8
  unset = 9
  builtin = 10
  readonly = 11
  local = 12
  declare = 13
  typeset = 14
  export_ = 15
  test = 16
  bracket = 17
  true_ = 18
  false_ = 19
  read = 20
  echo = 21
  printf = 22
  mapfile = 23
  readarray = 24
  cd = 25
  pushd = 26
  popd = 27
  dirs = 28
  pwd = 29
  source = 30
  umask = 31
  wait = 32
  jobs = 33
  fg = 34
  bg = 35
  shopt = 36
  complete = 37
  compgen = 38
  compopt = 39
  compadjust = 40
  getopts = 41
  command = 42
  type = 43
  hash = 44
  help = 45
  history = 46
  alias = 47
  unalias = 48
  bind = 49
  push = 50
  write = 51
  json = 52
  repr = 53
  use = 54
  opts = 55
  run = 56
  fork = 57
  forkwait = 58
  cat = 59
  ARRAY_SIZE = 60

_builtin_str = {
  1: 'builtin.colon',
  2: 'builtin.dot',
  3: 'builtin.exec_',
  4: 'builtin.eval',
  5: 'builtin.set',
  6: 'builtin.shift',
  7: 'builtin.times',
  8: 'builtin.trap',
  9: 'builtin.unset',
  10: 'builtin.builtin',
  11: 'builtin.readonly',
  12: 'builtin.local',
  13: 'builtin.declare',
  14: 'builtin.typeset',
  15: 'builtin.export_',
  16: 'builtin.test',
  17: 'builtin.bracket',
  18: 'builtin.true_',
  19: 'builtin.false_',
  20: 'builtin.read',
  21: 'builtin.echo',
  22: 'builtin.printf',
  23: 'builtin.mapfile',
  24: 'builtin.readarray',
  25: 'builtin.cd',
  26: 'builtin.pushd',
  27: 'builtin.popd',
  28: 'builtin.dirs',
  29: 'builtin.pwd',
  30: 'builtin.source',
  31: 'builtin.umask',
  32: 'builtin.wait',
  33: 'builtin.jobs',
  34: 'builtin.fg',
  35: 'builtin.bg',
  36: 'builtin.shopt',
  37: 'builtin.complete',
  38: 'builtin.compgen',
  39: 'builtin.compopt',
  40: 'builtin.compadjust',
  41: 'builtin.getopts',
  42: 'builtin.command',
  43: 'builtin.type',
  44: 'builtin.hash',
  45: 'builtin.help',
  46: 'builtin.history',
  47: 'builtin.alias',
  48: 'builtin.unalias',
  49: 'builtin.bind',
  50: 'builtin.push',
  51: 'builtin.write',
  52: 'builtin.json',
  53: 'builtin.repr',
  54: 'builtin.use',
  55: 'builtin.opts',
  56: 'builtin.run',
  57: 'builtin.fork',
  58: 'builtin.forkwait',
  59: 'builtin.cat',
}

def builtin_str(val):
  # type: (builtin_t) -> str
  return _builtin_str[val]

